// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genUserEvent.py

******************************************************************/

#include "common.h"
#include <stdint.h>
#include <eventheader/TraceLoggingProvider.h>
#include <user_events.h>

TRACELOGGING_DEFINE_PROVIDER(DotNETRuntimePrivate, "Microsoft-Windows-DotNETRuntimePrivate", (0x763FD754, 0x7086, 0x4dfe, 0x95, 0xEB, 0xC0, 0x1A, 0x46, 0xFA, 0xF4, 0xCA));

void InitDotNETRuntimePrivate()
{
    int err = TraceLoggingRegister(DotNETRuntimePrivate);
    _ASSERTE(err == 0);
}

bool DotNETRuntimePrivateEnabledByKeyword(uint8_t level, uint64_t keyword)
{
    if (!IsUserEventsEnabled())
    {
        return false;
    }

    switch (level)
    {
        case (0):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x1)) return true;
            }
            if (keyword == 0x2)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x2)) return true;
            }
            if (keyword == 0x4)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x4)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x10)) return true;
            }
            if (keyword == 0x400)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x400)) return true;
            }
            if (keyword == 0x2000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x2000)) return true;
            }
            if (keyword == 0x4000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x4000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x40000000)) return true;
            }
            if (keyword == 0x80000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x80000000)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 0x20)) return true;
            }
            break;
        case (1):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x1)) return true;
            }
            if (keyword == 0x2)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x2)) return true;
            }
            if (keyword == 0x4)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x4)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x10)) return true;
            }
            if (keyword == 0x400)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x400)) return true;
            }
            if (keyword == 0x2000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x2000)) return true;
            }
            if (keyword == 0x4000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x4000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x40000000)) return true;
            }
            if (keyword == 0x80000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x80000000)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0x20)) return true;
            }
            break;
        case (2):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x1)) return true;
            }
            if (keyword == 0x2)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x2)) return true;
            }
            if (keyword == 0x4)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x4)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x10)) return true;
            }
            if (keyword == 0x400)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x400)) return true;
            }
            if (keyword == 0x2000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x2000)) return true;
            }
            if (keyword == 0x4000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x4000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x40000000)) return true;
            }
            if (keyword == 0x80000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x80000000)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 2, 0x20)) return true;
            }
            break;
        case (3):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x1)) return true;
            }
            if (keyword == 0x2)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x2)) return true;
            }
            if (keyword == 0x4)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x4)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x10)) return true;
            }
            if (keyword == 0x400)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x400)) return true;
            }
            if (keyword == 0x2000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x2000)) return true;
            }
            if (keyword == 0x4000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x4000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x40000000)) return true;
            }
            if (keyword == 0x80000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x80000000)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 3, 0x20)) return true;
            }
            break;
        case (4):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x1)) return true;
            }
            if (keyword == 0x2)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x2)) return true;
            }
            if (keyword == 0x4)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x4)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x10)) return true;
            }
            if (keyword == 0x400)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x400)) return true;
            }
            if (keyword == 0x2000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x2000)) return true;
            }
            if (keyword == 0x4000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x4000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x40000000)) return true;
            }
            if (keyword == 0x80000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x80000000)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 0x20)) return true;
            }
            break;
        case (5):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x1)) return true;
            }
            if (keyword == 0x2)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x2)) return true;
            }
            if (keyword == 0x4)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x4)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x10)) return true;
            }
            if (keyword == 0x400)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x400)) return true;
            }
            if (keyword == 0x2000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x2000)) return true;
            }
            if (keyword == 0x4000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x4000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x40000000)) return true;
            }
            if (keyword == 0x80000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x80000000)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 0x20)) return true;
            }
            break;

    }
    return false;
}

BOOL UserEventsEventEnabledGCDecision(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCDecision(
    const BOOL DoCompact,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCDecision())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCDecision", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingBoolean(DoCompact)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCDecision_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCDecision_V1(
    const BOOL DoCompact,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCDecision_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCDecision_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingBoolean(DoCompact),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCSettings(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCSettings(
    const uint64_t SegmentSize,
    const uint64_t LargeObjectSegmentSize,
    const BOOL ServerGC,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCSettings())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCSettings", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(SegmentSize),
    TraceLoggingUInt64(LargeObjectSegmentSize),
    TraceLoggingBoolean(ServerGC)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCSettings_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCSettings_V1(
    const uint64_t SegmentSize,
    const uint64_t LargeObjectSegmentSize,
    const BOOL ServerGC,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCSettings_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCSettings_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(SegmentSize),
    TraceLoggingUInt64(LargeObjectSegmentSize),
    TraceLoggingBoolean(ServerGC),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCOptimized(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 1);
}

extern "C" ULONG UserEventsWriteEventGCOptimized(
    const uint64_t DesiredAllocation,
    const uint64_t NewAllocation,
    const unsigned int GenerationNumber,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCOptimized())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCOptimized", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(1),
    TraceLoggingUInt64(DesiredAllocation),
    TraceLoggingUInt64(NewAllocation),
    TraceLoggingUInt32(GenerationNumber)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCOptimized_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 1);
}

extern "C" ULONG UserEventsWriteEventGCOptimized_V1(
    const uint64_t DesiredAllocation,
    const uint64_t NewAllocation,
    const unsigned int GenerationNumber,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCOptimized_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCOptimized_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(1),
    TraceLoggingUInt64(DesiredAllocation),
    TraceLoggingUInt64(NewAllocation),
    TraceLoggingUInt32(GenerationNumber),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCPerHeapHistory(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCPerHeapHistory(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCPerHeapHistory())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCPerHeapHistory", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCPerHeapHistory_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCPerHeapHistory_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCPerHeapHistory_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCPerHeapHistory_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCGlobalHeapHistory(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCGlobalHeapHistory(
    const uint64_t FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCGlobalHeapHistory())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCGlobalHeapHistory", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(FinalYoungestDesired),
    TraceLoggingInt32(NumHeaps),
    TraceLoggingUInt32(CondemnedGeneration),
    TraceLoggingUInt32(Gen0ReductionCount),
    TraceLoggingUInt32(Reason),
    TraceLoggingUInt32(GlobalMechanisms)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCGlobalHeapHistory_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCGlobalHeapHistory_V1(
    const uint64_t FinalYoungestDesired,
    const signed int NumHeaps,
    const unsigned int CondemnedGeneration,
    const unsigned int Gen0ReductionCount,
    const unsigned int Reason,
    const unsigned int GlobalMechanisms,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCGlobalHeapHistory_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCGlobalHeapHistory_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(FinalYoungestDesired),
    TraceLoggingInt32(NumHeaps),
    TraceLoggingUInt32(CondemnedGeneration),
    TraceLoggingUInt32(Gen0ReductionCount),
    TraceLoggingUInt32(Reason),
    TraceLoggingUInt32(GlobalMechanisms),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCJoin(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 1);
}

extern "C" ULONG UserEventsWriteEventGCJoin(
    const unsigned int Heap,
    const unsigned int JoinTime,
    const unsigned int JoinType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCJoin())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCJoin", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(1),
    TraceLoggingUInt32(Heap),
    TraceLoggingUInt32(JoinTime),
    TraceLoggingUInt32(JoinType)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCJoin_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 1);
}

extern "C" ULONG UserEventsWriteEventGCJoin_V1(
    const unsigned int Heap,
    const unsigned int JoinTime,
    const unsigned int JoinType,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCJoin_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCJoin_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(1),
    TraceLoggingUInt32(Heap),
    TraceLoggingUInt32(JoinTime),
    TraceLoggingUInt32(JoinType),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkStackRoots(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkStackRoots(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkStackRoots())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkStackRoots", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkStackRoots_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkStackRoots_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkStackRoots_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkStackRoots_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkFinalizeQueueRoots(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkFinalizeQueueRoots(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkFinalizeQueueRoots())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkFinalizeQueueRoots", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkFinalizeQueueRoots_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkFinalizeQueueRoots_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkFinalizeQueueRoots_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkFinalizeQueueRoots_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkHandles(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkHandles(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkHandles())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkHandles", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkHandles_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkHandles_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkHandles_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkHandles_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkCards(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkCards(
    const unsigned int HeapNum,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkCards())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkCards", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvGCMarkCards_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventPrvGCMarkCards_V1(
    const unsigned int HeapNum,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvGCMarkCards_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvGCMarkCards_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(HeapNum),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCBegin(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCBegin(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCBegin())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCBegin", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC1stNonConEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC1stNonConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC1stNonConEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC1stNonConEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC1stConEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC1stConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC1stConEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC1stConEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC2ndNonConBegin(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC2ndNonConBegin(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC2ndNonConBegin())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC2ndNonConBegin", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC2ndNonConEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC2ndNonConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC2ndNonConEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC2ndNonConEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC2ndConBegin(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC2ndConBegin(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC2ndConBegin())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC2ndConBegin", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC2ndConEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC2ndConEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC2ndConEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC2ndConEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCPlanEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCPlanEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCPlanEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCPlanEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCSweepEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCSweepEnd(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCSweepEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCSweepEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCDrainMark(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCDrainMark(
    const uint64_t Objects,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCDrainMark())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCDrainMark", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(Objects),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCRevisit(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCRevisit(
    const uint64_t Pages,
    const uint64_t Objects,
    const unsigned int IsLarge,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCRevisit())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCRevisit", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(Pages),
    TraceLoggingUInt64(Objects),
    TraceLoggingUInt32(IsLarge),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCOverflow(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCOverflow(
    const uint64_t Min,
    const uint64_t Max,
    const uint64_t Objects,
    const unsigned int IsLarge,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCOverflow())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCOverflow", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(Min),
    TraceLoggingUInt64(Max),
    TraceLoggingUInt64(Objects),
    TraceLoggingUInt32(IsLarge),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCOverflow_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCOverflow_V1(
    const uint64_t Min,
    const uint64_t Max,
    const uint64_t Objects,
    const unsigned int IsLarge,
    const unsigned short ClrInstanceID,
    const unsigned int GenNumber,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCOverflow_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCOverflow_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt64(Min),
    TraceLoggingUInt64(Max),
    TraceLoggingUInt64(Objects),
    TraceLoggingUInt32(IsLarge),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt32(GenNumber)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCAllocWaitBegin(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCAllocWaitBegin(
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCAllocWaitBegin())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCAllocWaitBegin", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(Reason),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGCAllocWaitEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGCAllocWaitEnd(
    const unsigned int Reason,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGCAllocWaitEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGCAllocWaitEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(Reason),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCFullNotify(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCFullNotify(
    const unsigned int GenNumber,
    const unsigned int IsAlloc,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCFullNotify())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCFullNotify", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(GenNumber),
    TraceLoggingUInt32(IsAlloc)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCFullNotify_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventGCFullNotify_V1(
    const unsigned int GenNumber,
    const unsigned int IsAlloc,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCFullNotify_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GCFullNotify_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(GenNumber),
    TraceLoggingUInt32(IsAlloc),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBGC1stSweepEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1);
}

extern "C" ULONG UserEventsWriteEventBGC1stSweepEnd(
    const unsigned int GenNumber,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBGC1stSweepEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BGC1stSweepEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1),
    TraceLoggingUInt32(GenNumber),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEStartupStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEStartupStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEStartupStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEStartupStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEStartupStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEStartupStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEStartupStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEStartupStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEStartupEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEStartupEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEStartupEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEStartupEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEStartupEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEStartupEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEStartupEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEStartupEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSetup(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSetup(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSetup())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSetup", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSetup_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSetup_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSetup_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSetup_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSetupEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSetupEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSetupEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSetupEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSetupEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSetupEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSetupEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSetupEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdSysBases(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdSysBases(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdSysBases())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdSysBases", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdSysBases_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdSysBases_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdSysBases_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdSysBases_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdSysBasesEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdSysBasesEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdSysBasesEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdSysBasesEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdSysBasesEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdSysBasesEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdSysBasesEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdSysBasesEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExecExe(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExecExe(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExecExe())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExecExe", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExecExe_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExecExe_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExecExe_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExecExe_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExecExeEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExecExeEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExecExeEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExecExeEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExecExeEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExecExeEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExecExeEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExecExeEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMain(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventMain(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMain())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "Main", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMain_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventMain_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMain_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "Main_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMainEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventMainEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMainEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "MainEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMainEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventMainEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMainEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "MainEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledApplyPolicyStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventApplyPolicyStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledApplyPolicyStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ApplyPolicyStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledApplyPolicyStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventApplyPolicyStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledApplyPolicyStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ApplyPolicyStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledApplyPolicyEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventApplyPolicyEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledApplyPolicyEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ApplyPolicyEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledApplyPolicyEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventApplyPolicyEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledApplyPolicyEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ApplyPolicyEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdLibShFolder(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdLibShFolder(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdLibShFolder())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdLibShFolder", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdLibShFolder_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdLibShFolder_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdLibShFolder_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdLibShFolder_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdLibShFolderEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdLibShFolderEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdLibShFolderEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdLibShFolderEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLdLibShFolderEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLdLibShFolderEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLdLibShFolderEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LdLibShFolderEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrestubWorker(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventPrestubWorker(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrestubWorker())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrestubWorker", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrestubWorker_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventPrestubWorker_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrestubWorker_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrestubWorker_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrestubWorkerEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventPrestubWorkerEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrestubWorkerEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrestubWorkerEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrestubWorkerEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventPrestubWorkerEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrestubWorkerEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrestubWorkerEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGetInstallationStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventGetInstallationStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGetInstallationStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GetInstallationStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGetInstallationStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventGetInstallationStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGetInstallationStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GetInstallationStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGetInstallationEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventGetInstallationEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGetInstallationEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GetInstallationEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGetInstallationEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventGetInstallationEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGetInstallationEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GetInstallationEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledOpenHModule(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventOpenHModule(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledOpenHModule())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "OpenHModule", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledOpenHModule_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventOpenHModule_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledOpenHModule_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "OpenHModule_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledOpenHModuleEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventOpenHModuleEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledOpenHModuleEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "OpenHModuleEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledOpenHModuleEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventOpenHModuleEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledOpenHModuleEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "OpenHModuleEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExplicitBindStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExplicitBindStart(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExplicitBindStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExplicitBindStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExplicitBindStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExplicitBindStart_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExplicitBindStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExplicitBindStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExplicitBindEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExplicitBindEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExplicitBindEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExplicitBindEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExplicitBindEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventExplicitBindEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExplicitBindEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ExplicitBindEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledParseXml(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventParseXml(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledParseXml())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ParseXml", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledParseXml_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventParseXml_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledParseXml_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ParseXml_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledParseXmlEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventParseXmlEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledParseXmlEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ParseXmlEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledParseXmlEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventParseXmlEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledParseXmlEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ParseXmlEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitDefaultDomain(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitDefaultDomain(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitDefaultDomain())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitDefaultDomain", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitDefaultDomain_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitDefaultDomain_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitDefaultDomain_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitDefaultDomain_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitDefaultDomainEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitDefaultDomainEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitDefaultDomainEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitDefaultDomainEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitDefaultDomainEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitDefaultDomainEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitDefaultDomainEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitDefaultDomainEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitSecurity(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitSecurity(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitSecurity())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitSecurity", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitSecurity_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitSecurity_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitSecurity_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitSecurity_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitSecurityEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitSecurityEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitSecurityEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitSecurityEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledInitSecurityEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventInitSecurityEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledInitSecurityEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "InitSecurityEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAllowBindingRedirs(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventAllowBindingRedirs(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAllowBindingRedirs())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "AllowBindingRedirs", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAllowBindingRedirs_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventAllowBindingRedirs_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAllowBindingRedirs_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "AllowBindingRedirs_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAllowBindingRedirsEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventAllowBindingRedirsEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAllowBindingRedirsEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "AllowBindingRedirsEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAllowBindingRedirsEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventAllowBindingRedirsEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAllowBindingRedirsEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "AllowBindingRedirsEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSync(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSync(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSync())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSync", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSync_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSync_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSync_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSync_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSyncEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSyncEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSyncEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSyncEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEEConfigSyncEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventEEConfigSyncEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEEConfigSyncEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EEConfigSyncEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionBinding(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionBinding(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionBinding())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionBinding", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionBinding_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionBinding_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionBinding_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionBinding_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionBindingEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionBindingEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionBindingEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionBindingEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionBindingEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionBindingEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionBindingEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionBindingEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderCatchCall(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLoaderCatchCall(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderCatchCall())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderCatchCall", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderCatchCall_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLoaderCatchCall_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderCatchCall_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderCatchCall_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderCatchCallEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLoaderCatchCallEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderCatchCallEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderCatchCallEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderCatchCallEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventLoaderCatchCallEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderCatchCallEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderCatchCallEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionInit(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionInit(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionInit())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionInit", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionInit_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionInit_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionInit_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionInit_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionInitEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionInitEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionInitEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionInitEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionInitEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionInitEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionInitEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionInitEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionAppCtx(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionAppCtx(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionAppCtx())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionAppCtx", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionAppCtx_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionAppCtx_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionAppCtx_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionAppCtx_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionAppCtxEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionAppCtxEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionAppCtxEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionAppCtxEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionAppCtxEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusionAppCtxEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionAppCtxEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionAppCtxEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusion2EE(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusion2EE(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusion2EE())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "Fusion2EE", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusion2EE_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusion2EE_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusion2EE_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "Fusion2EE_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusion2EEEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusion2EEEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusion2EEEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "Fusion2EEEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusion2EEEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventFusion2EEEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusion2EEEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "Fusion2EEEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledSecurityCatchCall(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventSecurityCatchCall(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledSecurityCatchCall())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "SecurityCatchCall", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledSecurityCatchCall_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventSecurityCatchCall_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledSecurityCatchCall_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "SecurityCatchCall_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledSecurityCatchCallEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventSecurityCatchCallEnd(
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledSecurityCatchCallEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "SecurityCatchCallEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledSecurityCatchCallEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2147483648);
}

extern "C" ULONG UserEventsWriteEventSecurityCatchCallEnd_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledSecurityCatchCallEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "SecurityCatchCallEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2147483648),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCLRStackWalkPrivate(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 0, 1073741824);
}

extern "C" ULONG UserEventsWriteEventCLRStackWalkPrivate(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCLRStackWalkPrivate())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "CLRStackWalkPrivate", ActivityId, RelatedActivityId, TraceLoggingLevel(0), TraceLoggingKeyword(1073741824),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt8(Reserved1),
    TraceLoggingUInt8(Reserved2),
    TraceLoggingUInt32(FrameCount),
    TraceLoggingPointer(Stack)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleRangeLoadPrivate(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 536870912);
}

extern "C" ULONG UserEventsWriteEventModuleRangeLoadPrivate(
    const unsigned short ClrInstanceID,
    const uint64_t ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    const unsigned char IBCType,
    const unsigned short SectionType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleRangeLoadPrivate())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ModuleRangeLoadPrivate", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870912),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt32(RangeBegin),
    TraceLoggingUInt32(RangeSize),
    TraceLoggingUInt8(RangeType),
    TraceLoggingUInt8(IBCType),
    TraceLoggingUInt16(SectionType)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingPolicyPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingPolicyPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingPolicyPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingPolicyPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingPolicyPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingPolicyPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingPolicyPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingPolicyPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingNgenPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingNgenPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingNgenPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingNgenPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingNgenPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingNgenPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingNgenPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingNgenPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingLookupAndProbingPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingLookupAndProbingPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingLookupAndProbingPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingLookupAndProbingPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingLookupAndProbingPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingLookupAndProbingPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingLookupAndProbingPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingLookupAndProbingPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingDownloadPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingDownloadPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingDownloadPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingDownloadPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBindingDownloadPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventBindingDownloadPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBindingDownloadPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BindingDownloadPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderAssemblyInitPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderAssemblyInitPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderAssemblyInitPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderAssemblyInitPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderAssemblyInitPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderAssemblyInitPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderAssemblyInitPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderAssemblyInitPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderMappingPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderMappingPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderMappingPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderMappingPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderMappingPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderMappingPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderMappingPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderMappingPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderDeliverEventsPhaseStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderDeliverEventsPhaseStart(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderDeliverEventsPhaseStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderDeliverEventsPhaseStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledLoaderDeliverEventsPhaseEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventLoaderDeliverEventsPhaseEnd(
    const unsigned int AppDomainID,
    const unsigned int LoadContextID,
    const unsigned int FromLoaderCache,
    const unsigned int DynamicLoad,
    PCWSTR AssemblyCodebase,
    PCWSTR AssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledLoaderDeliverEventsPhaseEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "LoaderDeliverEventsPhaseEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt32(LoadContextID),
    TraceLoggingUInt32(FromLoaderCache),
    TraceLoggingUInt32(DynamicLoad),
    TraceLoggingString16(AssemblyCodebase),
    TraceLoggingString16(AssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEvidenceGenerated(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventEvidenceGenerated(
    const unsigned int Type,
    const unsigned int AppDomain,
    PCWSTR ILImage,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEvidenceGenerated())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EvidenceGenerated", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingUInt32(Type),
    TraceLoggingUInt32(AppDomain),
    TraceLoggingString16(ILImage),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleTransparencyComputationStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventModuleTransparencyComputationStart(
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleTransparencyComputationStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ModuleTransparencyComputationStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleTransparencyComputationEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventModuleTransparencyComputationEnd(
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsAllCritical,
    const BOOL IsAllTransparent,
    const BOOL IsTreatAsSafe,
    const BOOL IsOpportunisticallyCritical,
    const unsigned int SecurityRuleSet,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleTransparencyComputationEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ModuleTransparencyComputationEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingBoolean(IsAllCritical),
    TraceLoggingBoolean(IsAllTransparent),
    TraceLoggingBoolean(IsTreatAsSafe),
    TraceLoggingBoolean(IsOpportunisticallyCritical),
    TraceLoggingUInt32(SecurityRuleSet),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledTypeTransparencyComputationStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventTypeTransparencyComputationStart(
    PCWSTR Type,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledTypeTransparencyComputationStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "TypeTransparencyComputationStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Type),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledTypeTransparencyComputationEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventTypeTransparencyComputationEnd(
    PCWSTR Type,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsAllCritical,
    const BOOL IsAllTransparent,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledTypeTransparencyComputationEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "TypeTransparencyComputationEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Type),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingBoolean(IsAllCritical),
    TraceLoggingBoolean(IsAllTransparent),
    TraceLoggingBoolean(IsCritical),
    TraceLoggingBoolean(IsTreatAsSafe),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodTransparencyComputationStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventMethodTransparencyComputationStart(
    PCWSTR Method,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodTransparencyComputationStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "MethodTransparencyComputationStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Method),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodTransparencyComputationEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventMethodTransparencyComputationEnd(
    PCWSTR Method,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodTransparencyComputationEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "MethodTransparencyComputationEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Method),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingBoolean(IsCritical),
    TraceLoggingBoolean(IsTreatAsSafe),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFieldTransparencyComputationStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventFieldTransparencyComputationStart(
    PCWSTR Field,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFieldTransparencyComputationStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FieldTransparencyComputationStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Field),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFieldTransparencyComputationEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventFieldTransparencyComputationEnd(
    PCWSTR Field,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFieldTransparencyComputationEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FieldTransparencyComputationEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingString16(Field),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingBoolean(IsCritical),
    TraceLoggingBoolean(IsTreatAsSafe),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledTokenTransparencyComputationStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventTokenTransparencyComputationStart(
    const unsigned int Token,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledTokenTransparencyComputationStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "TokenTransparencyComputationStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingUInt32(Token),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledTokenTransparencyComputationEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 1024);
}

extern "C" ULONG UserEventsWriteEventTokenTransparencyComputationEnd(
    const unsigned int Token,
    PCWSTR Module,
    const unsigned int AppDomainID,
    const BOOL IsCritical,
    const BOOL IsTreatAsSafe,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledTokenTransparencyComputationEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "TokenTransparencyComputationEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(1024),
    TraceLoggingUInt32(Token),
    TraceLoggingString16(Module),
    TraceLoggingUInt32(AppDomainID),
    TraceLoggingBoolean(IsCritical),
    TraceLoggingBoolean(IsTreatAsSafe),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledNgenBindEvent(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 8);
}

extern "C" ULONG UserEventsWriteEventNgenBindEvent(
    const unsigned short ClrInstanceID,
    const uint64_t BindingID,
    const unsigned int ReasonCode,
    PCWSTR AssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledNgenBindEvent())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "NgenBindEvent", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(BindingID),
    TraceLoggingUInt32(ReasonCode),
    TraceLoggingString16(AssemblyName)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledJittedMethodRichDebugInfo(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 262144);
}

extern "C" ULONG UserEventsWriteEventJittedMethodRichDebugInfo(
    const unsigned short ClrInstanceID,
    const uint64_t MethodID,
    const uint64_t ReJITID,
    const uint64_t ILVersionID,
    const unsigned int ChunkIndex,
    const unsigned int DataSize,
    const BYTE* Data,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledJittedMethodRichDebugInfo())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "JittedMethodRichDebugInfo", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(262144),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ReJITID),
    TraceLoggingUInt64(ILVersionID),
    TraceLoggingUInt32(ChunkIndex),
    TraceLoggingUInt32(DataSize)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFailFast(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 1, 0);
}

extern "C" ULONG UserEventsWriteEventFailFast(
    PCWSTR FailFastUserMessage,
    const void* FailedEIP,
    const unsigned int OSExitCode,
    const unsigned int ClrExitCode,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFailFast())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FailFast", ActivityId, RelatedActivityId, TraceLoggingLevel(1), TraceLoggingKeyword(0),
    TraceLoggingString16(FailFastUserMessage),
    TraceLoggingPointer(FailedEIP),
    TraceLoggingUInt32(OSExitCode),
    TraceLoggingUInt32(ClrExitCode),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvFinalizeObject(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 1);
}

extern "C" ULONG UserEventsWriteEventPrvFinalizeObject(
    const void* TypeID,
    const void* ObjectID,
    const unsigned short ClrInstanceID,
    PCWSTR TypeName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvFinalizeObject())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvFinalizeObject", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(1),
    TraceLoggingPointer(TypeID),
    TraceLoggingPointer(ObjectID),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingString16(TypeName)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCCWRefCountChangeAnsi(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 8192);
}

extern "C" ULONG UserEventsWriteEventCCWRefCountChangeAnsi(
    const void* HandleID,
    const void* ObjectID,
    const void* COMInterfacePointer,
    const unsigned int NewRefCount,
    const uint64_t AppDomainID,
    LPCSTR ClassName,
    LPCSTR NameSpace,
    PCWSTR Operation,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCCWRefCountChangeAnsi())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "CCWRefCountChangeAnsi", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(8192),
    TraceLoggingPointer(HandleID),
    TraceLoggingPointer(ObjectID),
    TraceLoggingPointer(COMInterfacePointer),
    TraceLoggingUInt32(NewRefCount),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingString(ClassName),
    TraceLoggingString(NameSpace),
    TraceLoggingString16(Operation),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvSetGCHandle(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 16384);
}

extern "C" ULONG UserEventsWriteEventPrvSetGCHandle(
    const void* HandleID,
    const void* ObjectID,
    const unsigned int Kind,
    const unsigned int Generation,
    const uint64_t AppDomainID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvSetGCHandle())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvSetGCHandle", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(16384),
    TraceLoggingPointer(HandleID),
    TraceLoggingPointer(ObjectID),
    TraceLoggingUInt32(Kind),
    TraceLoggingUInt32(Generation),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPrvDestroyGCHandle(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 16384);
}

extern "C" ULONG UserEventsWriteEventPrvDestroyGCHandle(
    const void* HandleID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPrvDestroyGCHandle())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PrvDestroyGCHandle", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(16384),
    TraceLoggingPointer(HandleID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionMessageEvent(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventFusionMessageEvent(
    const unsigned short ClrInstanceID,
    const BOOL Prepend,
    PCWSTR Message,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionMessageEvent())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionMessageEvent", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingBoolean(Prepend),
    TraceLoggingString16(Message)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledFusionErrorCodeEvent(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 2);
}

extern "C" ULONG UserEventsWriteEventFusionErrorCodeEvent(
    const unsigned short ClrInstanceID,
    const unsigned int Category,
    const unsigned int ErrorCode,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledFusionErrorCodeEvent())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "FusionErrorCodeEvent", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(2),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt32(Category),
    TraceLoggingUInt32(ErrorCode)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledPinPlugAtGCTime(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 1);
}

extern "C" ULONG UserEventsWriteEventPinPlugAtGCTime(
    const void* PlugStart,
    const void* PlugEnd,
    const void* GapBeforeSize,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledPinPlugAtGCTime())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "PinPlugAtGCTime", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(1),
    TraceLoggingPointer(PlugStart),
    TraceLoggingPointer(PlugEnd),
    TraceLoggingPointer(GapBeforeSize),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCCWRefCountChange(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 8192);
}

extern "C" ULONG UserEventsWriteEventCCWRefCountChange(
    const void* HandleID,
    const void* ObjectID,
    const void* COMInterfacePointer,
    const unsigned int NewRefCount,
    const uint64_t AppDomainID,
    PCWSTR ClassName,
    PCWSTR NameSpace,
    PCWSTR Operation,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCCWRefCountChange())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "CCWRefCountChange", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(8192),
    TraceLoggingPointer(HandleID),
    TraceLoggingPointer(ObjectID),
    TraceLoggingPointer(COMInterfacePointer),
    TraceLoggingUInt32(NewRefCount),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingString16(ClassName),
    TraceLoggingString16(NameSpace),
    TraceLoggingString16(Operation),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAllocRequest(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 5, 16);
}

extern "C" ULONG UserEventsWriteEventAllocRequest(
    const void* LoaderHeapPtr,
    const void* MemoryAddress,
    const unsigned int RequestSize,
    const unsigned int Unused1,
    const uint64_t Unused2,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAllocRequest())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "AllocRequest", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(16),
    TraceLoggingPointer(LoaderHeapPtr),
    TraceLoggingPointer(MemoryAddress),
    TraceLoggingUInt32(RequestSize),
    TraceLoggingUInt32(Unused1),
    TraceLoggingUInt64(Unused2),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMulticoreJit(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 131072);
}

extern "C" ULONG UserEventsWriteEventMulticoreJit(
    const unsigned short ClrInstanceID,
    PCWSTR String1,
    PCWSTR String2,
    const signed int Int1,
    const signed int Int2,
    const signed int Int3,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMulticoreJit())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "MulticoreJit", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(131072),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingString16(String1),
    TraceLoggingString16(String2),
    TraceLoggingInt32(Int1),
    TraceLoggingInt32(Int2),
    TraceLoggingInt32(Int3)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMulticoreJitMethodCodeReturned(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 131072);
}

extern "C" ULONG UserEventsWriteEventMulticoreJitMethodCodeReturned(
    const unsigned short ClrInstanceID,
    const uint64_t ModuleID,
    const uint64_t MethodID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMulticoreJitMethodCodeReturned())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "MulticoreJitMethodCodeReturned", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(131072),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledIInspectableRuntimeClassName(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventIInspectableRuntimeClassName(
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledIInspectableRuntimeClassName())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "IInspectableRuntimeClassName", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledWinRTUnbox(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventWinRTUnbox(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledWinRTUnbox())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "WinRTUnbox", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(SecondTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCreateRCW(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventCreateRCW(
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCreateRCW())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "CreateRCW", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledRCWVariance(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventRCWVariance(
    PCWSTR TypeName,
    PCWSTR InterfaceTypeName,
    PCWSTR VariantInterfaceTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledRCWVariance())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "RCWVariance", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(InterfaceTypeName),
    TraceLoggingString16(VariantInterfaceTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledRCWIEnumerableCasting(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventRCWIEnumerableCasting(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledRCWIEnumerableCasting())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "RCWIEnumerableCasting", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(SecondTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCreateCCW(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventCreateCCW(
    PCWSTR TypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCreateCCW())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "CreateCCW", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCCWVariance(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventCCWVariance(
    PCWSTR TypeName,
    PCWSTR InterfaceTypeName,
    PCWSTR VariantInterfaceTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCCWVariance())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "CCWVariance", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(InterfaceTypeName),
    TraceLoggingString16(VariantInterfaceTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledObjectVariantMarshallingToNative(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventObjectVariantMarshallingToNative(
    PCWSTR TypeName,
    const signed int Int1,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledObjectVariantMarshallingToNative())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ObjectVariantMarshallingToNative", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingInt32(Int1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGetTypeFromGUID(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventGetTypeFromGUID(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGetTypeFromGUID())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GetTypeFromGUID", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(SecondTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGetTypeFromProgID(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventGetTypeFromProgID(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGetTypeFromProgID())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "GetTypeFromProgID", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(SecondTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledConvertToCallbackEtw(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventConvertToCallbackEtw(
    PCWSTR TypeName,
    PCWSTR SecondTypeName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledConvertToCallbackEtw())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ConvertToCallbackEtw", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingString16(SecondTypeName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledBeginCreateManagedReference(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventBeginCreateManagedReference(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledBeginCreateManagedReference())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "BeginCreateManagedReference", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledEndCreateManagedReference(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventEndCreateManagedReference(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledEndCreateManagedReference())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "EndCreateManagedReference", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledObjectVariantMarshallingToManaged(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimePrivate, 4, 32);
}

extern "C" ULONG UserEventsWriteEventObjectVariantMarshallingToManaged(
    PCWSTR TypeName,
    const signed int Int1,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledObjectVariantMarshallingToManaged())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimePrivate, "ObjectVariantMarshallingToManaged", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(32),
    TraceLoggingString16(TypeName),
    TraceLoggingInt32(Int1),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}


