// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genUserEvent.py

******************************************************************/

#include "common.h"
#include <stdint.h>
#include <eventheader/TraceLoggingProvider.h>
#include <user_events.h>

TRACELOGGING_DEFINE_PROVIDER(DotNETRuntimeRundown, "Microsoft-Windows-DotNETRuntimeRundown", (0xA669021C, 0xC450, 0x4609, 0xA0, 0x35, 0x5A, 0xF5, 0x9A, 0xF4, 0xDF, 0x18));

void InitDotNETRuntimeRundown()
{
    int err = TraceLoggingRegister(DotNETRuntimeRundown);
    _ASSERTE(err == 0);
}

bool DotNETRuntimeRundownEnabledByKeyword(uint8_t level, uint64_t keyword)
{
    if (!IsUserEventsEnabled())
    {
        return false;
    }

    switch (level)
    {
        case (0):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x1)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x10)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x20)) return true;
            }
            if (keyword == 0x40)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x40)) return true;
            }
            if (keyword == 0x100)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x100)) return true;
            }
            if (keyword == 0x800)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x800)) return true;
            }
            if (keyword == 0x10000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x10000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x40000000)) return true;
            }
            if (keyword == 0x1000000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 0x1000000000)) return true;
            }
            break;
        case (1):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x1)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x10)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x20)) return true;
            }
            if (keyword == 0x40)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x40)) return true;
            }
            if (keyword == 0x100)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x100)) return true;
            }
            if (keyword == 0x800)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x800)) return true;
            }
            if (keyword == 0x10000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x10000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x40000000)) return true;
            }
            if (keyword == 0x1000000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 1, 0x1000000000)) return true;
            }
            break;
        case (2):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x1)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x10)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x20)) return true;
            }
            if (keyword == 0x40)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x40)) return true;
            }
            if (keyword == 0x100)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x100)) return true;
            }
            if (keyword == 0x800)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x800)) return true;
            }
            if (keyword == 0x10000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x10000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x40000000)) return true;
            }
            if (keyword == 0x1000000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 2, 0x1000000000)) return true;
            }
            break;
        case (3):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x1)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x10)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x20)) return true;
            }
            if (keyword == 0x40)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x40)) return true;
            }
            if (keyword == 0x100)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x100)) return true;
            }
            if (keyword == 0x800)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x800)) return true;
            }
            if (keyword == 0x10000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x10000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x40000000)) return true;
            }
            if (keyword == 0x1000000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 3, 0x1000000000)) return true;
            }
            break;
        case (4):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x1)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x10)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x20)) return true;
            }
            if (keyword == 0x40)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x40)) return true;
            }
            if (keyword == 0x100)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x100)) return true;
            }
            if (keyword == 0x800)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x800)) return true;
            }
            if (keyword == 0x10000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x10000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x40000000)) return true;
            }
            if (keyword == 0x1000000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0x1000000000)) return true;
            }
            break;
        case (5):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0)) return true;
            }
            if (keyword == 0x1)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x1)) return true;
            }
            if (keyword == 0x8)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x8)) return true;
            }
            if (keyword == 0x10)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x10)) return true;
            }
            if (keyword == 0x20)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x20)) return true;
            }
            if (keyword == 0x40)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x40)) return true;
            }
            if (keyword == 0x100)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x100)) return true;
            }
            if (keyword == 0x800)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x800)) return true;
            }
            if (keyword == 0x10000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x10000)) return true;
            }
            if (keyword == 0x20000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x20000)) return true;
            }
            if (keyword == 0x40000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x40000)) return true;
            }
            if (keyword == 0x20000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x20000000)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x40000000)) return true;
            }
            if (keyword == 0x1000000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 0x1000000000)) return true;
            }
            break;

    }
    return false;
}

BOOL UserEventsEventEnabledCLRStackWalkDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 0, 1073741824);
}

extern "C" ULONG UserEventsWriteEventCLRStackWalkDCStart(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCLRStackWalkDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "CLRStackWalkDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(0), TraceLoggingKeyword(1073741824),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt8(Reserved1),
    TraceLoggingUInt8(Reserved2),
    TraceLoggingUInt32(FrameCount),
    TraceLoggingPointer(Stack)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledGCSettingsRundown(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0);
}

extern "C" ULONG UserEventsWriteEventGCSettingsRundown(
    const uint64_t HardLimit,
    const uint64_t LOHThreshold,
    const uint64_t PhysicalMemoryConfig,
    const uint64_t Gen0MinBudgetConfig,
    const uint64_t Gen0MaxBudgetConfig,
    const unsigned int HighMemPercentConfig,
    const unsigned int BitSettings,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledGCSettingsRundown())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "GCSettingsRundown", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(0),
    TraceLoggingUInt64(HardLimit),
    TraceLoggingUInt64(LOHThreshold),
    TraceLoggingUInt64(PhysicalMemoryConfig),
    TraceLoggingUInt64(Gen0MinBudgetConfig),
    TraceLoggingUInt64(Gen0MaxBudgetConfig),
    TraceLoggingUInt32(HighMemPercentConfig),
    TraceLoggingUInt32(BitSettings),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCStart(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCStart_V1(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStart_V2(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCStart_V2(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    const uint64_t ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStart_V2())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStart_V2", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ReJITID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCEnd(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCEnd_V1(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEnd_V2(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCEnd_V2(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    const unsigned short ClrInstanceID,
    const uint64_t ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEnd_V2())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEnd_V2", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ReJITID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStartVerbose(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCStartVerbose(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStartVerbose())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStartVerbose", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingString16(MethodNamespace),
    TraceLoggingString16(MethodName),
    TraceLoggingString16(MethodSignature)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStartVerbose_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCStartVerbose_V1(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStartVerbose_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStartVerbose_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingString16(MethodNamespace),
    TraceLoggingString16(MethodName),
    TraceLoggingString16(MethodSignature),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStartVerbose_V2(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCStartVerbose_V2(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    const uint64_t ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStartVerbose_V2())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStartVerbose_V2", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingString16(MethodNamespace),
    TraceLoggingString16(MethodName),
    TraceLoggingString16(MethodSignature),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ReJITID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEndVerbose(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCEndVerbose(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEndVerbose())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEndVerbose", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingString16(MethodNamespace),
    TraceLoggingString16(MethodName),
    TraceLoggingString16(MethodSignature)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEndVerbose_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCEndVerbose_V1(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEndVerbose_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEndVerbose_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingString16(MethodNamespace),
    TraceLoggingString16(MethodName),
    TraceLoggingString16(MethodSignature),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEndVerbose_V2(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 48);
}

extern "C" ULONG UserEventsWriteEventMethodDCEndVerbose_V2(
    const uint64_t MethodID,
    const uint64_t ModuleID,
    const uint64_t MethodStartAddress,
    const unsigned int MethodSize,
    const unsigned int MethodToken,
    const unsigned int MethodFlags,
    PCWSTR MethodNamespace,
    PCWSTR MethodName,
    PCWSTR MethodSignature,
    const unsigned short ClrInstanceID,
    const uint64_t ReJITID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEndVerbose_V2())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEndVerbose_V2", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(48),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(MethodStartAddress),
    TraceLoggingUInt32(MethodSize),
    TraceLoggingUInt32(MethodToken),
    TraceLoggingUInt32(MethodFlags),
    TraceLoggingString16(MethodNamespace),
    TraceLoggingString16(MethodName),
    TraceLoggingString16(MethodSignature),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ReJITID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCStartComplete(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCStartComplete(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCStartComplete())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCStartComplete", ActivityId, RelatedActivityId);
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCStartComplete_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCStartComplete_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCStartComplete_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCStartComplete_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(131128),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCEndComplete(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCEndComplete(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCEndComplete())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCEndComplete", ActivityId, RelatedActivityId);
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCEndComplete_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCEndComplete_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCEndComplete_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCEndComplete_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(131128),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCStartInit(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCStartInit(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCStartInit())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCStartInit", ActivityId, RelatedActivityId);
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCStartInit_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCStartInit_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCStartInit_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCStartInit_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(131128),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCEndInit(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCEndInit(    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCEndInit())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCEndInit", ActivityId, RelatedActivityId);
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDCEndInit_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 131128);
}

extern "C" ULONG UserEventsWriteEventDCEndInit_V1(
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDCEndInit_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DCEndInit_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(131128),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStartILToNativeMap(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 131072);
}

extern "C" ULONG UserEventsWriteEventMethodDCStartILToNativeMap(
    const uint64_t MethodID,
    const uint64_t ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStartILToNativeMap())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStartILToNativeMap", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(131072),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ReJITID),
    TraceLoggingUInt8(MethodExtent),
    TraceLoggingUInt16(CountOfMapEntries),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCStartILToNativeMap_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 131072);
}

extern "C" ULONG UserEventsWriteEventMethodDCStartILToNativeMap_V1(
    const uint64_t MethodID,
    const uint64_t ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    const uint64_t ILVersionID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCStartILToNativeMap_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCStartILToNativeMap_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(131072),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ReJITID),
    TraceLoggingUInt8(MethodExtent),
    TraceLoggingUInt16(CountOfMapEntries),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ILVersionID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEndILToNativeMap(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 131072);
}

extern "C" ULONG UserEventsWriteEventMethodDCEndILToNativeMap(
    const uint64_t MethodID,
    const uint64_t ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEndILToNativeMap())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEndILToNativeMap", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(131072),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ReJITID),
    TraceLoggingUInt8(MethodExtent),
    TraceLoggingUInt16(CountOfMapEntries),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledMethodDCEndILToNativeMap_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 5, 131072);
}

extern "C" ULONG UserEventsWriteEventMethodDCEndILToNativeMap_V1(
    const uint64_t MethodID,
    const uint64_t ReJITID,
    const unsigned char MethodExtent,
    const unsigned short CountOfMapEntries,
    const unsigned int* ILOffsets,
    const unsigned int* NativeOffsets,
    const unsigned short ClrInstanceID,
    const uint64_t ILVersionID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledMethodDCEndILToNativeMap_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "MethodDCEndILToNativeMap_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(5), TraceLoggingKeyword(131072),
    TraceLoggingUInt64(MethodID),
    TraceLoggingUInt64(ReJITID),
    TraceLoggingUInt8(MethodExtent),
    TraceLoggingUInt16(CountOfMapEntries),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ILVersionID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDomainModuleDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventDomainModuleDCStart(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDomainModuleDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DomainModuleDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDomainModuleDCStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventDomainModuleDCStart_V1(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDomainModuleDCStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DomainModuleDCStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDomainModuleDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventDomainModuleDCEnd(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDomainModuleDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DomainModuleDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledDomainModuleDCEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventDomainModuleDCEnd_V1(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledDomainModuleDCEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "DomainModuleDCEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventModuleDCStart(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleDCStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 536870920);
}

extern "C" ULONG UserEventsWriteEventModuleDCStart_V1(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleDCStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleDCStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870920),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleDCStart_V2(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 536870920);
}

extern "C" ULONG UserEventsWriteEventModuleDCStart_V2(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    PCWSTR ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    PCWSTR NativePdbBuildPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleDCStart_V2())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleDCStart_V2", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870920),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingGuid((uint8_t *)ManagedPdbSignature),
    TraceLoggingUInt32(ManagedPdbAge),
    TraceLoggingString16(ManagedPdbBuildPath),
    TraceLoggingGuid((uint8_t *)NativePdbSignature),
    TraceLoggingUInt32(NativePdbAge),
    TraceLoggingString16(NativePdbBuildPath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventModuleDCEnd(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleDCEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 536870920);
}

extern "C" ULONG UserEventsWriteEventModuleDCEnd_V1(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleDCEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleDCEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870920),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleDCEnd_V2(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 536870920);
}

extern "C" ULONG UserEventsWriteEventModuleDCEnd_V2(
    const uint64_t ModuleID,
    const uint64_t AssemblyID,
    const unsigned int ModuleFlags,
    const unsigned int Reserved1,
    PCWSTR ModuleILPath,
    PCWSTR ModuleNativePath,
    const unsigned short ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int ManagedPdbAge,
    PCWSTR ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int NativePdbAge,
    PCWSTR NativePdbBuildPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleDCEnd_V2())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleDCEnd_V2", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870920),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt32(ModuleFlags),
    TraceLoggingUInt32(Reserved1),
    TraceLoggingString16(ModuleILPath),
    TraceLoggingString16(ModuleNativePath),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingGuid((uint8_t *)ManagedPdbSignature),
    TraceLoggingUInt32(ManagedPdbAge),
    TraceLoggingString16(ManagedPdbBuildPath),
    TraceLoggingGuid((uint8_t *)NativePdbSignature),
    TraceLoggingUInt32(NativePdbAge),
    TraceLoggingString16(NativePdbBuildPath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAssemblyDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAssemblyDCStart(
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAssemblyDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AssemblyDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(AssemblyFlags),
    TraceLoggingString16(FullyQualifiedAssemblyName)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAssemblyDCStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAssemblyDCStart_V1(
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const uint64_t BindingID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAssemblyDCStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AssemblyDCStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt64(BindingID),
    TraceLoggingUInt32(AssemblyFlags),
    TraceLoggingString16(FullyQualifiedAssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAssemblyDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAssemblyDCEnd(
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAssemblyDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AssemblyDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(AssemblyFlags),
    TraceLoggingString16(FullyQualifiedAssemblyName)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAssemblyDCEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAssemblyDCEnd_V1(
    const uint64_t AssemblyID,
    const uint64_t AppDomainID,
    const uint64_t BindingID,
    const unsigned int AssemblyFlags,
    PCWSTR FullyQualifiedAssemblyName,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAssemblyDCEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AssemblyDCEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AssemblyID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt64(BindingID),
    TraceLoggingUInt32(AssemblyFlags),
    TraceLoggingString16(FullyQualifiedAssemblyName),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAppDomainDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAppDomainDCStart(
    const uint64_t AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAppDomainDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AppDomainDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(AppDomainFlags),
    TraceLoggingString16(AppDomainName)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAppDomainDCStart_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAppDomainDCStart_V1(
    const uint64_t AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    const unsigned int AppDomainIndex,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAppDomainDCStart_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AppDomainDCStart_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(AppDomainFlags),
    TraceLoggingString16(AppDomainName),
    TraceLoggingUInt32(AppDomainIndex),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAppDomainDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAppDomainDCEnd(
    const uint64_t AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAppDomainDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AppDomainDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(AppDomainFlags),
    TraceLoggingString16(AppDomainName)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledAppDomainDCEnd_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 8);
}

extern "C" ULONG UserEventsWriteEventAppDomainDCEnd_V1(
    const uint64_t AppDomainID,
    const unsigned int AppDomainFlags,
    PCWSTR AppDomainName,
    const unsigned int AppDomainIndex,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledAppDomainDCEnd_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "AppDomainDCEnd_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(8),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(AppDomainFlags),
    TraceLoggingString16(AppDomainName),
    TraceLoggingUInt32(AppDomainIndex),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledThreadDC(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 67584);
}

extern "C" ULONG UserEventsWriteEventThreadDC(
    const uint64_t ManagedThreadID,
    const uint64_t AppDomainID,
    const unsigned int Flags,
    const unsigned int ManagedThreadIndex,
    const unsigned int OSThreadID,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledThreadDC())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ThreadDC", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(67584),
    TraceLoggingUInt64(ManagedThreadID),
    TraceLoggingUInt64(AppDomainID),
    TraceLoggingUInt32(Flags),
    TraceLoggingUInt32(ManagedThreadIndex),
    TraceLoggingUInt32(OSThreadID),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleRangeDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 536870912);
}

extern "C" ULONG UserEventsWriteEventModuleRangeDCStart(
    const unsigned short ClrInstanceID,
    const uint64_t ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleRangeDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleRangeDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870912),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt32(RangeBegin),
    TraceLoggingUInt32(RangeSize),
    TraceLoggingUInt8(RangeType)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledModuleRangeDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 536870912);
}

extern "C" ULONG UserEventsWriteEventModuleRangeDCEnd(
    const unsigned short ClrInstanceID,
    const uint64_t ModuleID,
    const unsigned int RangeBegin,
    const unsigned int RangeSize,
    const unsigned char RangeType,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledModuleRangeDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ModuleRangeDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(536870912),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt64(ModuleID),
    TraceLoggingUInt32(RangeBegin),
    TraceLoggingUInt32(RangeSize),
    TraceLoggingUInt8(RangeType)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledRuntimeInformationDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0);
}

extern "C" ULONG UserEventsWriteEventRuntimeInformationDCStart(
    const unsigned short ClrInstanceID,
    const unsigned short Sku,
    const unsigned short BclMajorVersion,
    const unsigned short BclMinorVersion,
    const unsigned short BclBuildNumber,
    const unsigned short BclQfeNumber,
    const unsigned short VMMajorVersion,
    const unsigned short VMMinorVersion,
    const unsigned short VMBuildNumber,
    const unsigned short VMQfeNumber,
    const unsigned int StartupFlags,
    const unsigned char StartupMode,
    PCWSTR CommandLine,
    const GUID* ComObjectGuid,
    PCWSTR RuntimeDllPath,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledRuntimeInformationDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "RuntimeInformationDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(0),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt16(Sku),
    TraceLoggingUInt16(BclMajorVersion),
    TraceLoggingUInt16(BclMinorVersion),
    TraceLoggingUInt16(BclBuildNumber),
    TraceLoggingUInt16(BclQfeNumber),
    TraceLoggingUInt16(VMMajorVersion),
    TraceLoggingUInt16(VMMinorVersion),
    TraceLoggingUInt16(VMBuildNumber),
    TraceLoggingUInt16(VMQfeNumber),
    TraceLoggingUInt32(StartupFlags),
    TraceLoggingUInt8(StartupMode),
    TraceLoggingString16(CommandLine),
    TraceLoggingGuid((uint8_t *)ComObjectGuid),
    TraceLoggingString16(RuntimeDllPath)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledTieredCompilationSettingsDCStart(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 68719476736);
}

extern "C" ULONG UserEventsWriteEventTieredCompilationSettingsDCStart(
    const unsigned short ClrInstanceID,
    const unsigned int Flags,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledTieredCompilationSettingsDCStart())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "TieredCompilationSettingsDCStart", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(68719476736),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt32(Flags)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledExecutionCheckpointDCEnd(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeRundown, 4, 0);
}

extern "C" ULONG UserEventsWriteEventExecutionCheckpointDCEnd(
    const unsigned short ClrInstanceID,
    PCWSTR Name,
    const int64_t Timestamp,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledExecutionCheckpointDCEnd())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeRundown, "ExecutionCheckpointDCEnd", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(0),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingString16(Name),
    TraceLoggingInt64(Timestamp)
    );
    return ERROR_SUCCESS;
}


