// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genUserEvent.py

******************************************************************/

#include "common.h"
#include <stdint.h>
#include <eventheader/TraceLoggingProvider.h>
#include <user_events.h>

TRACELOGGING_DEFINE_PROVIDER(DotNETRuntimeStress, "Microsoft-Windows-DotNETRuntimeStress", (0xCC2BCBBA, 0x16B6, 0x4cf3, 0x89, 0x90, 0xD7, 0x4C, 0x2E, 0x8A, 0xF5, 0x00));

void InitDotNETRuntimeStress()
{
    int err = TraceLoggingRegister(DotNETRuntimeStress);
    _ASSERTE(err == 0);
}

bool DotNETRuntimeStressEnabledByKeyword(uint8_t level, uint64_t keyword)
{
    if (!IsUserEventsEnabled())
    {
        return false;
    }

    switch (level)
    {
        case (0):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 0, 0)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 0, 0x40000000)) return true;
            }
            break;
        case (1):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 1, 0)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 1, 0x40000000)) return true;
            }
            break;
        case (2):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 2, 0)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 2, 0x40000000)) return true;
            }
            break;
        case (3):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 3, 0)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 3, 0x40000000)) return true;
            }
            break;
        case (4):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 4, 0)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 4, 0x40000000)) return true;
            }
            break;
        case (5):
            if (keyword == 0)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 5, 0)) return true;
            }
            if (keyword == 0x40000000)
            {
                if (TraceLoggingProviderEnabled(DotNETRuntimeStress, 5, 0x40000000)) return true;
            }
            break;

    }
    return false;
}

BOOL UserEventsEventEnabledStressLogEvent(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeStress, 4, 0);
}

extern "C" ULONG UserEventsWriteEventStressLogEvent(
    const unsigned int Facility,
    const unsigned char LogLevel,
    LPCSTR Message,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledStressLogEvent())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeStress, "StressLogEvent", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(0),
    TraceLoggingUInt32(Facility),
    TraceLoggingUInt8(LogLevel),
    TraceLoggingString(Message)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledStressLogEvent_V1(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeStress, 4, 0);
}

extern "C" ULONG UserEventsWriteEventStressLogEvent_V1(
    const unsigned int Facility,
    const unsigned char LogLevel,
    LPCSTR Message,
    const unsigned short ClrInstanceID,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledStressLogEvent_V1())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeStress, "StressLogEvent_V1", ActivityId, RelatedActivityId, TraceLoggingLevel(4), TraceLoggingKeyword(0),
    TraceLoggingUInt32(Facility),
    TraceLoggingUInt8(LogLevel),
    TraceLoggingString(Message),
    TraceLoggingUInt16(ClrInstanceID)
    );
    return ERROR_SUCCESS;
}

BOOL UserEventsEventEnabledCLRStackWalkStress(void)
{
    return IsUserEventsEnabled() && TraceLoggingProviderEnabled(DotNETRuntimeStress, 0, 1073741824);
}

extern "C" ULONG UserEventsWriteEventCLRStackWalkStress(
    const unsigned short ClrInstanceID,
    const unsigned char Reserved1,
    const unsigned char Reserved2,
    const unsigned int FrameCount,
    const void** Stack,
    LPCGUID ActivityId,
    LPCGUID RelatedActivityId)
{
    if (!UserEventsEventEnabledCLRStackWalkStress())
        return ERROR_SUCCESS;
    TraceLoggingWriteActivity(DotNETRuntimeStress, "CLRStackWalkStress", ActivityId, RelatedActivityId, TraceLoggingLevel(0), TraceLoggingKeyword(1073741824),
    TraceLoggingUInt16(ClrInstanceID),
    TraceLoggingUInt8(Reserved1),
    TraceLoggingUInt8(Reserved2),
    TraceLoggingUInt32(FrameCount),
    TraceLoggingPointer(Stack)
    );
    return ERROR_SUCCESS;
}


